// SPDX-License-Identifier: MIT

pragma solidity ^0.6.12;
pragma experimental ABIEncoderV2;

// OZ Imports

import { IERC20 } from "@openzeppelin/contracts/token/ERC20/IERC20.sol";

// Tornado imports

import { ITornadoInstance } from "tornado-anonymity-mining/contracts/interfaces/ITornadoInstance.sol";

// Local imports

import { InstanceData } from "../InstanceRegistry.sol";

interface IFeeOracle {
    function getFee(
        IERC20 _torn,
        ITornadoInstance _instance,
        InstanceData memory _data,
        uint64 _feePercent,
        uint64 _feePercentDivisor
    ) external view returns (uint160);
}
